#!/usr/bin/python
import sys

if len(sys.argv) < 5:
    print "usage: adjust_rviz_config.py in_file out_file stereo nav (where stereo and nav are true or false)"
    sys.exit(1)
stereo = sys.argv[3]
nav = sys.argv[4]
if stereo not in ['true', 'false']:
    print "stereo was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav (where stereo and nav are true or false)"
    sys.exit(1)
if nav not in ['true', 'false']:
    print "nav was not true or false!  usage: adjust_rviz_config.py in_file out_file stereo nav (where stereo and nav are true or false)"
    sys.exit(1)

import os
home_path = os.environ["HOME"]
lines = file(sys.argv[1]).readlines()
outfile = file( sys.argv[2], 'w')

outfile.write('### THIS FILE AUTO-GENERATED FROM config/pr2_interactive_manipulation_base.vcg\n')
outfile.write('### IT IS SUGGESTED YOU DO NOT MODIFY THIS FILE.\n')
for line in lines:
    if line[:13] == 'Fixed\ Frame=':
        if nav == 'true':
            outfile.write('Fixed\ Frame=/map\n')
        else:
            outfile.write('Fixed\ Frame=/odom_combined\n')
    elif 'Publish\ Click\ Camera\ Display.Image\ Topic' in line:
        if stereo == 'true':
            outfile.write('Publish\ Click\ Camera\ Display.Image\ Topic=/wide_stereo/left/image_color\n')
        else:
            outfile.write('Publish\ Click\ Camera\ Display.Image\ Topic=/camera/rgb/image_color\n')
    else:
        outfile.write(line)
outfile.close()
