//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the pr2_grasp_adjust package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __pr2_grasp_adjust__DEBUGCONFIG_H__
#define __pr2_grasp_adjust__DEBUGCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace pr2_grasp_adjust
{
  class DebugConfigStatics;
  
  class DebugConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(DebugConfig &config, const DebugConfig &max, const DebugConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const DebugConfig &config1, const DebugConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, DebugConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const DebugConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, DebugConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const DebugConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T DebugConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (DebugConfig::* field);

      virtual void clamp(DebugConfig &config, const DebugConfig &max, const DebugConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const DebugConfig &config1, const DebugConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, DebugConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const DebugConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, DebugConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const DebugConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 70 "../cfg/Debug.cfg"
      bool run_continuous;
//#line 71 "../cfg/Debug.cfg"
      double seed_roll;
//#line 72 "../cfg/Debug.cfg"
      double seed_pitch;
//#line 73 "../cfg/Debug.cfg"
      double seed_yaw;
//#line 74 "../cfg/Debug.cfg"
      double seed_x;
//#line 75 "../cfg/Debug.cfg"
      double seed_y;
//#line 76 "../cfg/Debug.cfg"
      double seed_z;
//#line 77 "../cfg/Debug.cfg"
      double offset_roll;
//#line 78 "../cfg/Debug.cfg"
      double offset_pitch;
//#line 79 "../cfg/Debug.cfg"
      double offset_yaw;
//#line 80 "../cfg/Debug.cfg"
      double offset_x;
//#line 81 "../cfg/Debug.cfg"
      double offset_y;
//#line 82 "../cfg/Debug.cfg"
      double offset_z;
//#line 83 "../cfg/Debug.cfg"
      bool custom_pose;
//#line 84 "../cfg/Debug.cfg"
      std::string custom_frame;
//#line 85 "../cfg/Debug.cfg"
      double custom_roll;
//#line 86 "../cfg/Debug.cfg"
      double custom_pitch;
//#line 87 "../cfg/Debug.cfg"
      double custom_yaw;
//#line 88 "../cfg/Debug.cfg"
      double custom_x;
//#line 89 "../cfg/Debug.cfg"
      double custom_y;
//#line 90 "../cfg/Debug.cfg"
      double custom_z;
//#line 94 "../cfg/Debug.cfg"
      std::string status;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("DebugConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const DebugConfig &__max__ = __getMax__();
      const DebugConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const DebugConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const DebugConfig &__getDefault__();
    static const DebugConfig &__getMax__();
    static const DebugConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const DebugConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void DebugConfig::ParamDescription<std::string>::clamp(DebugConfig &config, const DebugConfig &max, const DebugConfig &min) const
  {
    return;
  }

  class DebugConfigStatics
  {
    friend class DebugConfig;
    
    DebugConfigStatics()
    {
//#line 70 "../cfg/Debug.cfg"
      __min__.run_continuous = 0;
//#line 70 "../cfg/Debug.cfg"
      __max__.run_continuous = 1;
//#line 70 "../cfg/Debug.cfg"
      __default__.run_continuous = 0;
//#line 70 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<bool>("run_continuous", "bool", 12, "Keep running the algorithm for display purposes", "", &DebugConfig::run_continuous)));
//#line 71 "../cfg/Debug.cfg"
      __min__.seed_roll = -90.0;
//#line 71 "../cfg/Debug.cfg"
      __max__.seed_roll = 90.0;
//#line 71 "../cfg/Debug.cfg"
      __default__.seed_roll = 0.0;
//#line 71 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_roll", "double", 8, "seed_roll", "", &DebugConfig::seed_roll)));
//#line 72 "../cfg/Debug.cfg"
      __min__.seed_pitch = -90.0;
//#line 72 "../cfg/Debug.cfg"
      __max__.seed_pitch = 90.0;
//#line 72 "../cfg/Debug.cfg"
      __default__.seed_pitch = 0.0;
//#line 72 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_pitch", "double", 8, "seed_pitch", "", &DebugConfig::seed_pitch)));
//#line 73 "../cfg/Debug.cfg"
      __min__.seed_yaw = -90.0;
//#line 73 "../cfg/Debug.cfg"
      __max__.seed_yaw = 90.0;
//#line 73 "../cfg/Debug.cfg"
      __default__.seed_yaw = 0.0;
//#line 73 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_yaw", "double", 8, "seed_yaw", "", &DebugConfig::seed_yaw)));
//#line 74 "../cfg/Debug.cfg"
      __min__.seed_x = -0.1;
//#line 74 "../cfg/Debug.cfg"
      __max__.seed_x = 0.1;
//#line 74 "../cfg/Debug.cfg"
      __default__.seed_x = 0.0;
//#line 74 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_x", "double", 8, "seed_x", "", &DebugConfig::seed_x)));
//#line 75 "../cfg/Debug.cfg"
      __min__.seed_y = -0.1;
//#line 75 "../cfg/Debug.cfg"
      __max__.seed_y = 0.1;
//#line 75 "../cfg/Debug.cfg"
      __default__.seed_y = 0.0;
//#line 75 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_y", "double", 8, "seed_y", "", &DebugConfig::seed_y)));
//#line 76 "../cfg/Debug.cfg"
      __min__.seed_z = -0.1;
//#line 76 "../cfg/Debug.cfg"
      __max__.seed_z = 0.1;
//#line 76 "../cfg/Debug.cfg"
      __default__.seed_z = 0.0;
//#line 76 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("seed_z", "double", 8, "seed_z", "", &DebugConfig::seed_z)));
//#line 77 "../cfg/Debug.cfg"
      __min__.offset_roll = -90.0;
//#line 77 "../cfg/Debug.cfg"
      __max__.offset_roll = 90.0;
//#line 77 "../cfg/Debug.cfg"
      __default__.offset_roll = 0.0;
//#line 77 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_roll", "double", 8, "offset_roll", "", &DebugConfig::offset_roll)));
//#line 78 "../cfg/Debug.cfg"
      __min__.offset_pitch = -90.0;
//#line 78 "../cfg/Debug.cfg"
      __max__.offset_pitch = 90.0;
//#line 78 "../cfg/Debug.cfg"
      __default__.offset_pitch = 0.0;
//#line 78 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_pitch", "double", 8, "offset_pitch", "", &DebugConfig::offset_pitch)));
//#line 79 "../cfg/Debug.cfg"
      __min__.offset_yaw = -90.0;
//#line 79 "../cfg/Debug.cfg"
      __max__.offset_yaw = 90.0;
//#line 79 "../cfg/Debug.cfg"
      __default__.offset_yaw = 0.0;
//#line 79 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_yaw", "double", 8, "offset_yaw", "", &DebugConfig::offset_yaw)));
//#line 80 "../cfg/Debug.cfg"
      __min__.offset_x = -0.1;
//#line 80 "../cfg/Debug.cfg"
      __max__.offset_x = 0.1;
//#line 80 "../cfg/Debug.cfg"
      __default__.offset_x = 0.0;
//#line 80 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_x", "double", 8, "offset_x", "", &DebugConfig::offset_x)));
//#line 81 "../cfg/Debug.cfg"
      __min__.offset_y = -0.1;
//#line 81 "../cfg/Debug.cfg"
      __max__.offset_y = 0.1;
//#line 81 "../cfg/Debug.cfg"
      __default__.offset_y = 0.0;
//#line 81 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_y", "double", 8, "offset_y", "", &DebugConfig::offset_y)));
//#line 82 "../cfg/Debug.cfg"
      __min__.offset_z = -0.1;
//#line 82 "../cfg/Debug.cfg"
      __max__.offset_z = 0.1;
//#line 82 "../cfg/Debug.cfg"
      __default__.offset_z = 0.0;
//#line 82 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("offset_z", "double", 8, "offset_z", "", &DebugConfig::offset_z)));
//#line 83 "../cfg/Debug.cfg"
      __min__.custom_pose = 0;
//#line 83 "../cfg/Debug.cfg"
      __max__.custom_pose = 1;
//#line 83 "../cfg/Debug.cfg"
      __default__.custom_pose = 0;
//#line 83 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<bool>("custom_pose", "bool", 12, "Use custom pose", "", &DebugConfig::custom_pose)));
//#line 84 "../cfg/Debug.cfg"
      __min__.custom_frame = "";
//#line 84 "../cfg/Debug.cfg"
      __max__.custom_frame = "";
//#line 84 "../cfg/Debug.cfg"
      __default__.custom_frame = "torso_lift_link";
//#line 84 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<std::string>("custom_frame", "str", 12, "pose frame_id", "", &DebugConfig::custom_frame)));
//#line 85 "../cfg/Debug.cfg"
      __min__.custom_roll = -180.0;
//#line 85 "../cfg/Debug.cfg"
      __max__.custom_roll = 180.0;
//#line 85 "../cfg/Debug.cfg"
      __default__.custom_roll = 0.0;
//#line 85 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_roll", "double", 8, "custom_roll", "", &DebugConfig::custom_roll)));
//#line 86 "../cfg/Debug.cfg"
      __min__.custom_pitch = -180.0;
//#line 86 "../cfg/Debug.cfg"
      __max__.custom_pitch = 180.0;
//#line 86 "../cfg/Debug.cfg"
      __default__.custom_pitch = 0.0;
//#line 86 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_pitch", "double", 8, "custom_pitch", "", &DebugConfig::custom_pitch)));
//#line 87 "../cfg/Debug.cfg"
      __min__.custom_yaw = -180.0;
//#line 87 "../cfg/Debug.cfg"
      __max__.custom_yaw = 180.0;
//#line 87 "../cfg/Debug.cfg"
      __default__.custom_yaw = 0.0;
//#line 87 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_yaw", "double", 8, "custom_yaw", "", &DebugConfig::custom_yaw)));
//#line 88 "../cfg/Debug.cfg"
      __min__.custom_x = -2.0;
//#line 88 "../cfg/Debug.cfg"
      __max__.custom_x = 2.0;
//#line 88 "../cfg/Debug.cfg"
      __default__.custom_x = 0.0;
//#line 88 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_x", "double", 8, "custom_x", "", &DebugConfig::custom_x)));
//#line 89 "../cfg/Debug.cfg"
      __min__.custom_y = -2.0;
//#line 89 "../cfg/Debug.cfg"
      __max__.custom_y = 2.0;
//#line 89 "../cfg/Debug.cfg"
      __default__.custom_y = 0.0;
//#line 89 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_y", "double", 8, "custom_y", "", &DebugConfig::custom_y)));
//#line 90 "../cfg/Debug.cfg"
      __min__.custom_z = -2.0;
//#line 90 "../cfg/Debug.cfg"
      __max__.custom_z = 2.0;
//#line 90 "../cfg/Debug.cfg"
      __default__.custom_z = 0.0;
//#line 90 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<double>("custom_z", "double", 8, "custom_z", "", &DebugConfig::custom_z)));
//#line 94 "../cfg/Debug.cfg"
      __min__.status = "";
//#line 94 "../cfg/Debug.cfg"
      __max__.status = "";
//#line 94 "../cfg/Debug.cfg"
      __default__.status = "status";
//#line 94 "../cfg/Debug.cfg"
      __param_descriptions__.push_back(DebugConfig::AbstractParamDescriptionConstPtr(new DebugConfig::ParamDescription<std::string>("status", "str", 99, "For returning text to reconfigure gui.", "", &DebugConfig::status)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<DebugConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<DebugConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    DebugConfig __max__;
    DebugConfig __min__;
    DebugConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const DebugConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static DebugConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &DebugConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const DebugConfig &DebugConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const DebugConfig &DebugConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const DebugConfig &DebugConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<DebugConfig::AbstractParamDescriptionConstPtr> &DebugConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const DebugConfigStatics *DebugConfig::__get_statics__()
  {
    const static DebugConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = DebugConfigStatics::get_instance();
    
    return statics;
  }

//#line 61 "../cfg/Debug.cfg"
      const int Debug_global_search = 0;
//#line 62 "../cfg/Debug.cfg"
      const int Debug_local_search = 1;
//#line 63 "../cfg/Debug.cfg"
      const int Debug_single_pose = 2;
}

#endif // __DEBUGRECONFIGURATOR_H__
