"""autogenerated by genmsg_py from PR2GripperEventDetectorData.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime

class PR2GripperEventDetectorData(roslib.message.Message):
  _md5sum = "9536d682ef6215440ecc47846d4117c2"
  _type = "pr2_gripper_sensor_msgs/PR2GripperEventDetectorData"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Time the data was recorded at
time stamp

# true if the trigger conditions have been met 
# (see PR2GripperEventDetectorCommand)
bool trigger_conditions_met

# true if the pressure sensors detected a slip event
# slip events occur when the finger pressure sensors
# high-freq. content exceeds the slip_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool slip_event

# true if the hand-mounted accelerometer detected a contact acceleration
# acceleration events occur when the palm accelerometer
# high-freq. content exceeds the acc_trigger_magnitude variable
# (see PR2GripperEventDetectorCommand)
bool acceleration_event

# the high-freq acceleration vector that was last seen (x,y,z)
float64[3] acceleration_vector
"""
  __slots__ = ['stamp','trigger_conditions_met','slip_event','acceleration_event','acceleration_vector']
  _slot_types = ['time','bool','bool','bool','float64[3]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       stamp,trigger_conditions_met,slip_event,acceleration_event,acceleration_vector
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(PR2GripperEventDetectorData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      if self.trigger_conditions_met is None:
        self.trigger_conditions_met = False
      if self.slip_event is None:
        self.slip_event = False
      if self.acceleration_event is None:
        self.acceleration_event = False
      if self.acceleration_vector is None:
        self.acceleration_vector = [0.,0.,0.]
    else:
      self.stamp = roslib.rostime.Time()
      self.trigger_conditions_met = False
      self.slip_event = False
      self.acceleration_event = False
      self.acceleration_vector = [0.,0.,0.]

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_2I3B.pack(_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event))
      buff.write(_struct_3d.pack(*self.acceleration_vector))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event,) = _struct_2I3B.unpack(str[start:end])
      self.trigger_conditions_met = bool(self.trigger_conditions_met)
      self.slip_event = bool(self.slip_event)
      self.acceleration_event = bool(self.acceleration_event)
      start = end
      end += 24
      self.acceleration_vector = _struct_3d.unpack(str[start:end])
      self.stamp.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_2I3B.pack(_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event))
      buff.write(self.acceleration_vector.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      end = 0
      _x = self
      start = end
      end += 11
      (_x.stamp.secs, _x.stamp.nsecs, _x.trigger_conditions_met, _x.slip_event, _x.acceleration_event,) = _struct_2I3B.unpack(str[start:end])
      self.trigger_conditions_met = bool(self.trigger_conditions_met)
      self.slip_event = bool(self.slip_event)
      self.acceleration_event = bool(self.acceleration_event)
      start = end
      end += 24
      self.acceleration_vector = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_2I3B = struct.Struct("<2I3B")
_struct_3d = struct.Struct("<3d")
