/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-electric-pr2-object-manipulation-0.5.19/debian/ros-electric-pr2-object-manipulation/opt/ros/electric/stacks/pr2_object_manipulation/perception/fast_plane_detection/msg/Plane.msg */
#ifndef FAST_PLANE_DETECTION_MESSAGE_PLANE_H
#define FAST_PLANE_DETECTION_MESSAGE_PLANE_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "geometry_msgs/PoseStamped.h"
#include "geometry_msgs/PointStamped.h"
#include "geometry_msgs/Vector3Stamped.h"
#include "geometry_msgs/PointStamped.h"
#include "geometry_msgs/Point32.h"
#include "geometry_msgs/Point32.h"
#include "geometry_msgs/Point32.h"
#include "geometry_msgs/Point32.h"

namespace fast_plane_detection
{
template <class ContainerAllocator>
struct Plane_ {
  typedef Plane_<ContainerAllocator> Type;

  Plane_()
  : pose()
  , plane_point()
  , normal()
  , slave_point()
  , top_left()
  , top_right()
  , bottom_left()
  , bottom_right()
  , result(0)
  , percentage_inliers(0.0)
  , percentage_disp_inliers(0)
  , percentage_valid_disp(0)
  , error(0.0)
  {
  }

  Plane_(const ContainerAllocator& _alloc)
  : pose(_alloc)
  , plane_point(_alloc)
  , normal(_alloc)
  , slave_point(_alloc)
  , top_left(_alloc)
  , top_right(_alloc)
  , bottom_left(_alloc)
  , bottom_right(_alloc)
  , result(0)
  , percentage_inliers(0.0)
  , percentage_disp_inliers(0)
  , percentage_valid_disp(0)
  , error(0.0)
  {
  }

  typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _pose_type;
   ::geometry_msgs::PoseStamped_<ContainerAllocator>  pose;

  typedef  ::geometry_msgs::PointStamped_<ContainerAllocator>  _plane_point_type;
   ::geometry_msgs::PointStamped_<ContainerAllocator>  plane_point;

  typedef  ::geometry_msgs::Vector3Stamped_<ContainerAllocator>  _normal_type;
   ::geometry_msgs::Vector3Stamped_<ContainerAllocator>  normal;

  typedef  ::geometry_msgs::PointStamped_<ContainerAllocator>  _slave_point_type;
   ::geometry_msgs::PointStamped_<ContainerAllocator>  slave_point;

  typedef  ::geometry_msgs::Point32_<ContainerAllocator>  _top_left_type;
   ::geometry_msgs::Point32_<ContainerAllocator>  top_left;

  typedef  ::geometry_msgs::Point32_<ContainerAllocator>  _top_right_type;
   ::geometry_msgs::Point32_<ContainerAllocator>  top_right;

  typedef  ::geometry_msgs::Point32_<ContainerAllocator>  _bottom_left_type;
   ::geometry_msgs::Point32_<ContainerAllocator>  bottom_left;

  typedef  ::geometry_msgs::Point32_<ContainerAllocator>  _bottom_right_type;
   ::geometry_msgs::Point32_<ContainerAllocator>  bottom_right;

  typedef int32_t _result_type;
  int32_t result;

  typedef float _percentage_inliers_type;
  float percentage_inliers;

  typedef int32_t _percentage_disp_inliers_type;
  int32_t percentage_disp_inliers;

  typedef int32_t _percentage_valid_disp_type;
  int32_t percentage_valid_disp;

  typedef float _error_type;
  float error;

  enum { SUCCESS = 1 };
  enum { FEW_INLIERS = 2 };
  enum { NO_PLANE = 3 };
  enum { OTHER_ERROR = 4 };

private:
  static const char* __s_getDataType_() { return "fast_plane_detection/Plane"; }
public:
  ROS_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROS_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "e876d3c2247eeda0c0207fae33ce01a9"; }
public:
  ROS_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROS_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "# Informs that a plane has been detected at a given location\n\
\n\
# The pose gives you the transform that take you to the coordinate system\n\
# of the plane, with the origin somewhere in the plane and the \n\
# z axis normal to the plane\n\
geometry_msgs/PoseStamped pose\n\
			  \n\
# Point + normal vector of the plane\n\
geometry_msgs/PointStamped plane_point\n\
geometry_msgs/Vector3Stamped normal\n\
geometry_msgs/PointStamped slave_point\n\
			   \n\
# These values give you the observed extents of the plane, along x and y,\n\
# in the plane's own coordinate system (above)\n\
# there is no guarantee that the origin of the plane coordinate system is\n\
# inside the boundary defined by these values. \n\
geometry_msgs/Point32 top_left\n\
geometry_msgs/Point32 top_right\n\
\n\
geometry_msgs/Point32 bottom_left\n\
geometry_msgs/Point32 bottom_right\n\
 \n\
# There is no guarantee that the plane doe NOT extend further than these \n\
# values; this is just as far as we've observed it.\n\
\n\
# Whether the detection has succeeded or failed\n\
int32 SUCCESS = 1\n\
int32 FEW_INLIERS = 2\n\
int32 NO_PLANE = 3\n\
int32 OTHER_ERROR = 4\n\
int32 result\n\
\n\
# inliers over whole region\n\
float32 percentage_inliers\n\
# inliers of valid disparities\n\
int32 percentage_disp_inliers\n\
# number of valid disparities\n\
int32 percentage_valid_disp\n\
\n\
# confidence indicators of plane detection\n\
# mean squared error\n\
float32 error\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PointStamped\n\
# This represents a Point with reference coordinate frame and timestamp\n\
Header header\n\
Point point\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Point32\n\
# This contains the position of a point in free space(with 32 bits of precision).\n\
# It is recommeded to use Point wherever possible instead of Point32.  \n\
# \n\
# This recommendation is to promote interoperability.  \n\
#\n\
# This message is designed to take up less space when sending\n\
# lots of points at once, as in the case of a PointCloud.  \n\
\n\
float32 x\n\
float32 y\n\
float32 z\n\
"; }
public:
  ROS_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROS_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROS_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, pose);
    ros::serialization::serialize(stream, plane_point);
    ros::serialization::serialize(stream, normal);
    ros::serialization::serialize(stream, slave_point);
    ros::serialization::serialize(stream, top_left);
    ros::serialization::serialize(stream, top_right);
    ros::serialization::serialize(stream, bottom_left);
    ros::serialization::serialize(stream, bottom_right);
    ros::serialization::serialize(stream, result);
    ros::serialization::serialize(stream, percentage_inliers);
    ros::serialization::serialize(stream, percentage_disp_inliers);
    ros::serialization::serialize(stream, percentage_valid_disp);
    ros::serialization::serialize(stream, error);
    return stream.getData();
  }

  ROS_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, pose);
    ros::serialization::deserialize(stream, plane_point);
    ros::serialization::deserialize(stream, normal);
    ros::serialization::deserialize(stream, slave_point);
    ros::serialization::deserialize(stream, top_left);
    ros::serialization::deserialize(stream, top_right);
    ros::serialization::deserialize(stream, bottom_left);
    ros::serialization::deserialize(stream, bottom_right);
    ros::serialization::deserialize(stream, result);
    ros::serialization::deserialize(stream, percentage_inliers);
    ros::serialization::deserialize(stream, percentage_disp_inliers);
    ros::serialization::deserialize(stream, percentage_valid_disp);
    ros::serialization::deserialize(stream, error);
    return stream.getData();
  }

  ROS_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(pose);
    size += ros::serialization::serializationLength(plane_point);
    size += ros::serialization::serializationLength(normal);
    size += ros::serialization::serializationLength(slave_point);
    size += ros::serialization::serializationLength(top_left);
    size += ros::serialization::serializationLength(top_right);
    size += ros::serialization::serializationLength(bottom_left);
    size += ros::serialization::serializationLength(bottom_right);
    size += ros::serialization::serializationLength(result);
    size += ros::serialization::serializationLength(percentage_inliers);
    size += ros::serialization::serializationLength(percentage_disp_inliers);
    size += ros::serialization::serializationLength(percentage_valid_disp);
    size += ros::serialization::serializationLength(error);
    return size;
  }

  typedef boost::shared_ptr< ::fast_plane_detection::Plane_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::fast_plane_detection::Plane_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct Plane
typedef  ::fast_plane_detection::Plane_<std::allocator<void> > Plane;

typedef boost::shared_ptr< ::fast_plane_detection::Plane> PlanePtr;
typedef boost::shared_ptr< ::fast_plane_detection::Plane const> PlaneConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::fast_plane_detection::Plane_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::fast_plane_detection::Plane_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace fast_plane_detection

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::fast_plane_detection::Plane_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::fast_plane_detection::Plane_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::fast_plane_detection::Plane_<ContainerAllocator> > {
  static const char* value() 
  {
    return "e876d3c2247eeda0c0207fae33ce01a9";
  }

  static const char* value(const  ::fast_plane_detection::Plane_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xe876d3c2247eeda0ULL;
  static const uint64_t static_value2 = 0xc0207fae33ce01a9ULL;
};

template<class ContainerAllocator>
struct DataType< ::fast_plane_detection::Plane_<ContainerAllocator> > {
  static const char* value() 
  {
    return "fast_plane_detection/Plane";
  }

  static const char* value(const  ::fast_plane_detection::Plane_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::fast_plane_detection::Plane_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Informs that a plane has been detected at a given location\n\
\n\
# The pose gives you the transform that take you to the coordinate system\n\
# of the plane, with the origin somewhere in the plane and the \n\
# z axis normal to the plane\n\
geometry_msgs/PoseStamped pose\n\
			  \n\
# Point + normal vector of the plane\n\
geometry_msgs/PointStamped plane_point\n\
geometry_msgs/Vector3Stamped normal\n\
geometry_msgs/PointStamped slave_point\n\
			   \n\
# These values give you the observed extents of the plane, along x and y,\n\
# in the plane's own coordinate system (above)\n\
# there is no guarantee that the origin of the plane coordinate system is\n\
# inside the boundary defined by these values. \n\
geometry_msgs/Point32 top_left\n\
geometry_msgs/Point32 top_right\n\
\n\
geometry_msgs/Point32 bottom_left\n\
geometry_msgs/Point32 bottom_right\n\
 \n\
# There is no guarantee that the plane doe NOT extend further than these \n\
# values; this is just as far as we've observed it.\n\
\n\
# Whether the detection has succeeded or failed\n\
int32 SUCCESS = 1\n\
int32 FEW_INLIERS = 2\n\
int32 NO_PLANE = 3\n\
int32 OTHER_ERROR = 4\n\
int32 result\n\
\n\
# inliers over whole region\n\
float32 percentage_inliers\n\
# inliers of valid disparities\n\
int32 percentage_disp_inliers\n\
# number of valid disparities\n\
int32 percentage_valid_disp\n\
\n\
# confidence indicators of plane detection\n\
# mean squared error\n\
float32 error\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PointStamped\n\
# This represents a Point with reference coordinate frame and timestamp\n\
Header header\n\
Point point\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Point32\n\
# This contains the position of a point in free space(with 32 bits of precision).\n\
# It is recommeded to use Point wherever possible instead of Point32.  \n\
# \n\
# This recommendation is to promote interoperability.  \n\
#\n\
# This message is designed to take up less space when sending\n\
# lots of points at once, as in the case of a PointCloud.  \n\
\n\
float32 x\n\
float32 y\n\
float32 z\n\
";
  }

  static const char* value(const  ::fast_plane_detection::Plane_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::fast_plane_detection::Plane_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.pose);
    stream.next(m.plane_point);
    stream.next(m.normal);
    stream.next(m.slave_point);
    stream.next(m.top_left);
    stream.next(m.top_right);
    stream.next(m.bottom_left);
    stream.next(m.bottom_right);
    stream.next(m.result);
    stream.next(m.percentage_inliers);
    stream.next(m.percentage_disp_inliers);
    stream.next(m.percentage_valid_disp);
    stream.next(m.error);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct Plane_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::fast_plane_detection::Plane_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::fast_plane_detection::Plane_<ContainerAllocator> & v) 
  {
    s << indent << "pose: ";
s << std::endl;
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "plane_point: ";
s << std::endl;
    Printer< ::geometry_msgs::PointStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.plane_point);
    s << indent << "normal: ";
s << std::endl;
    Printer< ::geometry_msgs::Vector3Stamped_<ContainerAllocator> >::stream(s, indent + "  ", v.normal);
    s << indent << "slave_point: ";
s << std::endl;
    Printer< ::geometry_msgs::PointStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.slave_point);
    s << indent << "top_left: ";
s << std::endl;
    Printer< ::geometry_msgs::Point32_<ContainerAllocator> >::stream(s, indent + "  ", v.top_left);
    s << indent << "top_right: ";
s << std::endl;
    Printer< ::geometry_msgs::Point32_<ContainerAllocator> >::stream(s, indent + "  ", v.top_right);
    s << indent << "bottom_left: ";
s << std::endl;
    Printer< ::geometry_msgs::Point32_<ContainerAllocator> >::stream(s, indent + "  ", v.bottom_left);
    s << indent << "bottom_right: ";
s << std::endl;
    Printer< ::geometry_msgs::Point32_<ContainerAllocator> >::stream(s, indent + "  ", v.bottom_right);
    s << indent << "result: ";
    Printer<int32_t>::stream(s, indent + "  ", v.result);
    s << indent << "percentage_inliers: ";
    Printer<float>::stream(s, indent + "  ", v.percentage_inliers);
    s << indent << "percentage_disp_inliers: ";
    Printer<int32_t>::stream(s, indent + "  ", v.percentage_disp_inliers);
    s << indent << "percentage_valid_disp: ";
    Printer<int32_t>::stream(s, indent + "  ", v.percentage_valid_disp);
    s << indent << "error: ";
    Printer<float>::stream(s, indent + "  ", v.error);
  }
};


} // namespace message_operations
} // namespace ros

#endif // FAST_PLANE_DETECTION_MESSAGE_PLANE_H

