from Numeric import *
from numpy import *
from numpy.linalg import *

class Triangle:
	def __init__(self, verts):
		#vertices are three-dimensional points x:0-st coordinate and so on
		A = array(verts[0])
		B = array(verts[1])
		C = array(verts[2])
		self.normal = cross(A-B, A-C)
		self.normal = self.normal / linalg.norm(self.normal)
		self.vertices = [A,B,C]
		self.childs = list()
		self.mappedNormals = list()

	def getCenter(self):
		return (self.vertices[0]+self.vertices[1]+self.vertices[2])/3.

	def reset(self):
		self.mappedNormals = list()

	def normalize(self, vert):
		#push vertex to the sphere
		r = vert; 
		mag = vert[0] * vert[0] + vert[1] * vert[1] + vert[2] * vert[2]; 
		if (mag != 0.0):
			mag = 1.0 / sqrt(mag)
			r = r * mag

		return r

	def subdivide(self):
		a = self.normalize((self.vertices[0] + self.vertices[2]) / 2)
		b = self.normalize((self.vertices[0] + self.vertices[1]) / 2)
		c = self.normalize((self.vertices[1] + self.vertices[2]) / 2)
		self.childs.append(Triangle([self.vertices[0], b, a]))
		self.childs.append(Triangle([b, self.vertices[1], c]))
		self.childs.append(Triangle([a, b, c]))
		self.childs.append(Triangle([a, c, self.vertices[2]]))
		return self.childs

	def dotProduct(self, n):
		return dot(self.normal,n)

	def findCell(self, normal):
		if(len(self.childs) == 0):
			return self

		maxDot = -1000
		cell = 0

		for chi in self.childs:
			dotP = dot(normal,chi.normal)
			if dotP > maxDot:
				maxDot = dotP
				cell = chi

		return cell.findCell(normal)

	def addInfo(self, point, normal, interpolated, cellId):
		self.mappedNormals.append((point,normal, interpolated, cellId))			
