"""autogenerated by genmsg_py from normals_vfh_db_estimatorRequest.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import std_msgs.msg
import sensor_msgs.msg

class normals_vfh_db_estimatorRequest(roslib.message.Message):
  _md5sum = "49ba0e431d9d565e2e6ad06c9ac04d5f"
  _type = "vfh_recognizer_db/normals_vfh_db_estimatorRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """sensor_msgs/PointCloud2 view
geometry_msgs/Pose transform
std_msgs/Int32 model_id
std_msgs/Int32 iteration

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: std_msgs/Int32
int32 data
"""
  __slots__ = ['view','transform','model_id','iteration']
  _slot_types = ['sensor_msgs/PointCloud2','geometry_msgs/Pose','std_msgs/Int32','std_msgs/Int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       view,transform,model_id,iteration
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(normals_vfh_db_estimatorRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.view is None:
        self.view = sensor_msgs.msg.PointCloud2()
      if self.transform is None:
        self.transform = geometry_msgs.msg.Pose()
      if self.model_id is None:
        self.model_id = std_msgs.msg.Int32()
      if self.iteration is None:
        self.iteration = std_msgs.msg.Int32()
    else:
      self.view = sensor_msgs.msg.PointCloud2()
      self.transform = geometry_msgs.msg.Pose()
      self.model_id = std_msgs.msg.Int32()
      self.iteration = std_msgs.msg.Int32()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.view.header.seq, _x.view.header.stamp.secs, _x.view.header.stamp.nsecs))
      _x = self.view.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.view.height, _x.view.width))
      length = len(self.view.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.view.fields:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.view.is_bigendian, _x.view.point_step, _x.view.row_step))
      _x = self.view.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B7d2i.pack(_x.view.is_dense, _x.transform.position.x, _x.transform.position.y, _x.transform.position.z, _x.transform.orientation.x, _x.transform.orientation.y, _x.transform.orientation.z, _x.transform.orientation.w, _x.model_id.data, _x.iteration.data))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.view is None:
        self.view = sensor_msgs.msg.PointCloud2()
      if self.transform is None:
        self.transform = geometry_msgs.msg.Pose()
      if self.model_id is None:
        self.model_id = std_msgs.msg.Int32()
      if self.iteration is None:
        self.iteration = std_msgs.msg.Int32()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.view.header.seq, _x.view.header.stamp.secs, _x.view.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.view.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.view.height, _x.view.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.view.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.view.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.view.is_bigendian, _x.view.point_step, _x.view.row_step,) = _struct_B2I.unpack(str[start:end])
      self.view.is_bigendian = bool(self.view.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.view.data = str[start:end]
      _x = self
      start = end
      end += 65
      (_x.view.is_dense, _x.transform.position.x, _x.transform.position.y, _x.transform.position.z, _x.transform.orientation.x, _x.transform.orientation.y, _x.transform.orientation.z, _x.transform.orientation.w, _x.model_id.data, _x.iteration.data,) = _struct_B7d2i.unpack(str[start:end])
      self.view.is_dense = bool(self.view.is_dense)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.view.header.seq, _x.view.header.stamp.secs, _x.view.header.stamp.nsecs))
      _x = self.view.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.view.height, _x.view.width))
      length = len(self.view.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.view.fields:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.view.is_bigendian, _x.view.point_step, _x.view.row_step))
      _x = self.view.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_B7d2i.pack(_x.view.is_dense, _x.transform.position.x, _x.transform.position.y, _x.transform.position.z, _x.transform.orientation.x, _x.transform.orientation.y, _x.transform.orientation.z, _x.transform.orientation.w, _x.model_id.data, _x.iteration.data))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.view is None:
        self.view = sensor_msgs.msg.PointCloud2()
      if self.transform is None:
        self.transform = geometry_msgs.msg.Pose()
      if self.model_id is None:
        self.model_id = std_msgs.msg.Int32()
      if self.iteration is None:
        self.iteration = std_msgs.msg.Int32()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.view.header.seq, _x.view.header.stamp.secs, _x.view.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.view.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.view.height, _x.view.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.view.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.view.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.view.is_bigendian, _x.view.point_step, _x.view.row_step,) = _struct_B2I.unpack(str[start:end])
      self.view.is_bigendian = bool(self.view.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.view.data = str[start:end]
      _x = self
      start = end
      end += 65
      (_x.view.is_dense, _x.transform.position.x, _x.transform.position.y, _x.transform.position.z, _x.transform.orientation.x, _x.transform.orientation.y, _x.transform.orientation.z, _x.transform.orientation.w, _x.model_id.data, _x.iteration.data,) = _struct_B7d2i.unpack(str[start:end])
      self.view.is_dense = bool(self.view.is_dense)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_IBI = struct.Struct("<IBI")
_struct_3I = struct.Struct("<3I")
_struct_2I = struct.Struct("<2I")
_struct_B2I = struct.Struct("<B2I")
_struct_B7d2i = struct.Struct("<B7d2i")
"""autogenerated by genmsg_py from normals_vfh_db_estimatorResponse.msg. Do not edit."""
import roslib.message
import struct


class normals_vfh_db_estimatorResponse(roslib.message.Message):
  _md5sum = "d41d8cd98f00b204e9800998ecf8427e"
  _type = "vfh_recognizer_db/normals_vfh_db_estimatorResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
"""
  __slots__ = []
  _slot_types = []

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(normals_vfh_db_estimatorResponse, self).__init__(*args, **kwds)

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      pass
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      pass
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
class normals_vfh_db_estimator(roslib.message.ServiceDefinition):
  _type          = 'vfh_recognizer_db/normals_vfh_db_estimator'
  _md5sum = '49ba0e431d9d565e2e6ad06c9ac04d5f'
  _request_class  = normals_vfh_db_estimatorRequest
  _response_class = normals_vfh_db_estimatorResponse
